SystemOrganization addCategory: #'tODE-Amber'!

WAComponent subclass: #TOAmberAbstractComponent
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object
	^ object! !

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object: anObject
	object := anObject! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderContentOn: json
	self subclassResponsibility! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderJsonOn: aRenderer
	self renderWithContext: aRenderer context! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
rendererClass
	^ WAJsonCanvas! !

TOAmberAbstractComponent subclass: #TOAmberFrameComponent
	instanceVariableNames: 'expression target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberFrameComponent class methodsFor: 'accessing' stamp: 'dkh 10/25/2011 10:10'!
applicationPath

	^'tools/amber/frame'! !

!TOAmberFrameComponent class methodsFor: 'class initialization' stamp: 'dkh 10/25/2011 10:07'!
initialize
	"self initialize"

	self register! !

!TOAmberFrameComponent class methodsFor: 'class initialization' stamp: 'dkh 10/25/2011 10:10'!
register
    "self register"

    ^ (WAJsonAdmin register: self asApplicationAt: self applicationPath)
        exceptionHandler: TOAmberErrorHandler;
        yourself! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression

	^expression! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression: aString

	expression := aString! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:45'!
notifier
	^ TOPharoCompilationRequestor new requestor: self! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/15/2011 10:15'!
object
	object ifNil: [ ^ object := TORoot current currentSession homeObject ].
	^ object! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/25/2011 22:02'!
renderContentOn: json
    | renderer |
    renderer := (self object tODEAmberRendererClass new)
        frameComponent: self;
        object: self object;
        yourself.
	renderer renderAmberFrameOn: json! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:31'!
states

	^#()! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:26'!
target
    "target is a one-shot variable:
     _self - object displayed in current session
     _blank - new session created to display the object"

    | ans |
    target ifNil: [ ^ '_self' ].
    ans := target.
    target := nil.
    ^ ans! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/23/2011 11:41'!
target: aByteString 
	target := aByteString! !

WAComponent subclass: #TOAmberCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:15'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberCounter class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:17'!
description
	^ 'Amber & Seaside-JSON example counter'! !

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:22'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-counter'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application	"exception handler for TOMain is always TOSeasideErrorHandler"! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:33'!
renderContentOn: html
	html script url: '/Kaliningrad/js/amber.js'.
	html script with: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	html strong: 'Amber Counter:'.
	html break.
	html script with: 'smalltalk.TOASeasideCounter._open()'.
! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 9/26/2011 21:47'!
updateRoot: aHtmlRoot

	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Amber Counter'.
! !

WAComponent subclass: #TOAmberMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 9/25/2011 11:33'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberMain class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:08'!
description
	^ 'tODE Amber Main'! !

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 10/5/2011 17:32'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-tODE'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application.
	KOAmberBrowser addAmberFile: 'tODEAmberClient.js'	"until tODE can be used to edit Amber code"! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:52'!
renderContentOn: html
	html document addLoadScript: (html jQuery ajaxSetup onError: html javascript refresh).
	html script with: 'smalltalk.TOAMain._open()'! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 16:06'!
style
	^'
html {height:100%; overflow:hidden}
	body {
		overflow:auto;
		height:100%;
		margin:0;
		padding:0;
		font-size:11px;
		font-family:Verdana}
 	h1 {color:#ff7200;background:#ddd;margin:0;padding:4px;padding-bottom:0px}

		.ui-layout-content {
                        height: 100%;
                        width: 100%;
			overflow:		auto; /* add scrolling to content-divs (panel-wrappers) */

			border-top:		0 !!important; /* tab-buttons above this DIV already has a border-bottom */
		}


		.ui-tabs-nav li {

			white-space:	nowrap;

		}

		.ui-tabs-nav li a {

			font-size:		1em !!important;

			padding:		4px 1.5ex 3px !!important;

		}

		.ui-tabs-panel {

			font-size:		1em !!important;

			padding:		0 1em !!important;

		}


	.ui-layout-resizer {   
		background: #DDD; 
	}

 
	.ui-layout-toggler {  
		background: #AAA; 
	} 
	.ui-layout-toggler .content {
	   font-size: 12px; /* IMPORTANT: default = 1px */
	   font-weight: bold;
	   text-align: center}
	.ui-layout-toggler-north .content {   
		 font-size: 7px;
	} 

#north .ltab, #north .rtab, #north .mtab {
    height: 22px;
    float: left;
}

#north .ltab, #north .rtab {
    width: 8px;
}

#north .rtab {
    margin-right: 1px;
}

#north .mtab {
    line-height: 20px;
}

'
! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 13:57'!
updateRoot: aHtmlRoot

	aHtmlRoot title: 'Amber tODE'.
	aHtmlRoot addScript: '$(document).ready(function () {
	$(''body'').layout({ 
north : {
   size : ''auto''
,  resizable : false
,  togglerLength_open : 20
,  togglerLength_closed : 20
,  togglerContent_closed : ''v''
,  togglerContent_open : ''^''
}
, south : {
   size : 120
}
});
})'.
	aHtmlRoot script url: '/Kaliningrad/js/amber.js'.
	aHtmlRoot addScript: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	super updateRoot: aHtmlRoot! !

WAWalkbackErrorHandler subclass: #TOAmberErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberErrorHandler class methodsFor: 'exception handling' stamp: 'dkh 10/9/2011 13:52'!
exceptionSelector
	^ super exceptionSelector, Halt! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleException: anException
	(Halt handles: anException)
		ifTrue: [ ^ self handleHalt: anException ].

	^ super handleException: anException! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleHalt: anError

	^ self handleDefault: anError! !

WAJsonComponent subclass: #TOJsonCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:06'!
initialize
	"self initialize"
	
	self register! !

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:05'!
register
	(WAJsonAdmin register: self asApplicationAt: 'tools/json-counter')
		exceptionHandler: WAHtmlHaltAndErrorHandler.! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/24/2011 22:04'!
decrease
	count := count - 1! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/25/2011 10:22'!
increase
	count := count + 1! !

!TOJsonCounter methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:04'!
initialize
	super initialize.
	count := 0! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:10'!
renderActionsOn: json
	json
		key: 'increase' value: [ json callback: [ self increase ] ];
		key: 'decrease' value: [ json callback: [ self decrease ] ]! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:09'!
renderStateOn: json
	json key: 'count' value: count! !

!Object methodsFor: '*tode-amber' stamp: 'dkh 10/24/2011 10:08'!
tODEAmberRendererClass
    ^ TOAmberInspectorRenderer! !

Object subclass: #TOAmberAbstractRenderer
	instanceVariableNames: 'object frameComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

TOAmberAbstractRenderer subclass: #TOAmberAbstractFrameRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 09:47'!
configurationInfo
    | configurationInfo wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self packageClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ 
                            configurationInfo := config.
                            ^ config ] ] ].
    ^ configurationInfo! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:16'!
expression

	^self frameComponent expression! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:16'!
expression: exp

	self frameComponent expression: exp! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:06'!
expressionContext

	^self object! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:16'!
notifier

	^self frameComponent notifier! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 09:47'!
packageClass
    ^ self object class theNonMetaClass! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/26/2011 09:47'!
packageInfo
    | wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self packageClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ ^ pkg ] ] ].
    ^ MBPackageInfo named: wc packageName! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 09:28'!
renderAmberFrameOn: json
    self expression
        ifNotNil: [ :exp | 
            | result |
            self expression: nil.
            result := TORoot current currentSession currentSystem
                evaluate: exp
                in: nil
                to: self expressionContext
                notifying: self notifier
                ifFail: [ self error: 'evaluation failed' ].
            json object: [ json key: 'url' value: [ json callback: [ self frameComponent object: result ] ] ].
            ^ self ].
    json
        object: [ 
            json key: 'target' value: self frameComponent target.
            json key: 'header' value: [ self renderHeaderOn: json ].
            json key: 'sessionTitle' value: [ self renderSessionTitleOn: json ].
            json key: 'instanceTitle' value: [ self renderInstanceTitleOn: json ].
            json
                key: 'url'
                value: [ 
                    | o |
                    o := self frameComponent object.
                    json
                        callback: [ 
                            self requestContext request url queryFields at: 'expression' ifPresent: [ :exp | self expression: exp ].
                            self frameComponent object: o ] ].
            self renderObjectOn: json ]! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 21:16'!
renderHeaderOn: json
    json
        object: [ 
            json
                key: 'configuration'
                value: [ 
                    | config |
                    self
                        renderHeaderOn: json
                        with:
                            ((config := self configurationInfo)
                                ifNil: [ 
                                    (TOAmberCreateConfigurationRenderer new)
                                        frameComponent: self frameComponent;
                                        object: config;
                                        yourself ]
                                ifNotNil: [ 
                                    (TOAmberConfigurationRenderer new)
                                        frameComponent: self frameComponent;
                                        object: config;
                                        yourself ]) ].
            json key: 'package' value: self packageInfo printString ]! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 21:10'!
renderHeaderOn: json with: renderer
    json
        object: [ 
            renderer object
                ifNil: [ json key: 'title' value: 'No configuration' ]
                ifNotNil: [ json key: 'title' value: renderer object printString ].
            json key: 'state' value: [ renderer renderContentOn: json ].
            json key: 'renderBlockSource' value: renderer renderBlockSource ]! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 09:28'!
renderInstanceTitleOn: json
	json render: self object tODETitle! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 21:15'!
renderObjectOn: json
    json key: 'state' value: [ self renderContentOn: json ].
    json key: 'renderBlockSource' value: self renderBlockSource! !

!TOAmberAbstractFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/26/2011 09:31'!
renderSessionTitleOn: json
	self renderInstanceTitleOn: json! !

!TOAmberAbstractFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:17'!
requestContext

	^self frameComponent requestContext! !

TOAmberAbstractFrameRenderer subclass: #TOAmberInspectorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberInspectorRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 08:57'!
members
    ^ TORoot current currentSession currentSystem
        inspectorField: #tODEBasicInspectorFields
        from: self object class
        to: nil
        for: self object! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 10:10'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    html table
        with: [ 
            obj state members
                do: [ :member | 
                    html tr
                        with: [ 
                            | td |
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | key url |
                                    key := member key.
                                    (url := key at: 2) isNil
                                        ifTrue: [ html with: (key at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (key at: 1) ] ].
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | value url |
                                    value := member value.
                                    (url := value at: 2) isNil
                                        ifTrue: [ html with: (value at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (value at: 1) ] ] ] ] ] ]! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 09:10'!
renderContentOn: json
    json object: [ self renderMembersOn: json ]! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 09:59'!
renderMembersOn: json
    | members |
    members := self members.
    json
        key: 'members'
        value: [ 
            json
                array: [ 
                    members
                        do: [ :fieldSpec | 
                            json
                                value: [ 
                                    json
                                        object: [ 
                                            json
                                                key: 'key'
                                                value: [ 
                                                    json
                                                        array: [ 
                                                            json value: fieldSpec keyLabel.
                                                            fieldSpec hasKey
                                                                ifTrue: [ 
                                                                    json
                                                                        value: [ 
                                                                            json
                                                                                callback: [ 
                                                                                    (self frameComponent)
                                                                                        target: self target;
                                                                                        object: fieldSpec key ] ] ]
                                                                ifFalse: [ json value: nil ] ] ].
                                            json
                                                key: 'value'
                                                value: [ 
                                                    json
                                                        array: [ 
                                                            json value: fieldSpec valueLabel.
                                                            fieldSpec hasValue
                                                                ifTrue: [ 
                                                                    json
                                                                        value: [ 
                                                                            json
                                                                                callback: [ 
                                                                                    (self frameComponent)
                                                                                        target: self target;
                                                                                        object: fieldSpec value ] ] ]
                                                                ifFalse: [ json value: nil ] ] ] ] ] ] ] ]! !

!TOAmberInspectorRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 09:58'!
target
    ^ '_self'! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/22/2011 11:02'!
frameComponent
    ^ frameComponent! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/22/2011 11:02'!
frameComponent: anObject
    frameComponent := anObject! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object
	^ object! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object: anObject
	object := anObject! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 18:01'!
renderBlockMethod
    ^[:frame :obj :html :main | ]
! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 18:01'!
renderBlockSource

	^self renderBlockMethod asString! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 11:40'!
renderContentOn: json
    ^ json value: 'null'! !

TOAmberAbstractRenderer subclass: #TOAmberConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberConfigurationRenderer methodsFor: 'actions' stamp: 'dkh 10/25/2011 10:24'!
createConfiguration: configName inRepository: repoName
self error: 'Create configuration: ' , configName , ' in: ' , repoName.
    Transcript
        cr;
        show: 'Create configuration: ' , configName , ' in: ' , repoName! !

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 19:07'!
renderBlockMethod
    ^ [ :frame :obj :html :main | html with: 'Hello world' ]! !

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 11:39'!
renderContentOn: json
    ^ json value: 'null'! !

!TOAmberConfigurationRenderer methodsFor: 'accessing' stamp: 'dkh 10/16/2011 19:31'!
repositories
	^ (MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ])
		sorted: [ :a :b | a description <= b description ]! !

TOAmberConfigurationRenderer subclass: #TOAmberCreateConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 09:57'!
renderBlockMethod
    ^ [ :frame :obj :html :main | 
    | configName repoName |
    (html button)
        onClick: [ 
                    | url |
                    url := obj state createConfigurationURL , '&configName='
                        , (frame encodeURIComponent: configName asJQuery val) , '&repoName='
                        , (frame encodeURIComponent: repoName asJQuery val).
                    frame
                        getRequest: url
                        main: main
                        do: [ :jsonObject | 
                            frame session push: jsonObject url.
                            main renderCenter ] ];
        with: 'Create configuration'.
    configName := html inputWithExampleText: 'Configuration name'.
    repoName := html select with: [ obj state repositories do: [ :repository | html option with: repository ] ] ]! !

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 11:40'!
renderContentOn: json 
    ^ json
        object: [ 
            json key: 'repositories' value: [ json array: [ self repositories do: [ :repo | json value: repo description ] ] ].
            json
                key: 'createConfigurationURL'
                value: [ 
                    json
                        callback: [ 
                            | fc repoName configName |
                            fc := self frameComponent.
                            fc requestContext request url queryFields
                                at: 'repoName'
                                ifPresent: [ :val | repoName := val ].
                            fc requestContext request url queryFields
                                at: 'configName'
                                ifPresent: [ :val | configName := val ].
                            self createConfiguration: configName inRepository: repoName.
                            fc object: 'SUCCESS!!' ] ] ]! !

TOAmberAbstractRenderer subclass: #TOAmberNullRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!
TOAmberFrameComponent initialize!
TOAmberCounter initialize!
TOAmberMain initialize!
TOJsonCounter initialize!
